/*

f-cpu/qdcpoc/main.c
created Wed Jul 11 01:23:48 2001 by whygee@f-cpu.org

Beware ! don't do what is written here at home !
Don't let children look, or they'll be scared to death !

(C) YG all rights reserved. you're warned !!!
read f-cpu/qdcpoc/about.txt for the details.

*/

#include "qdcpoc.h"

/* pretty printing, useful inside GDB */
void lli(UMAX i) {
  printf("%016llX\n",i);
}


void qdcpoc_error(char * message, int n) {
  fprintf(stderr, "\nError : %s\7\n", message);
  exit(n);
} /* never returns... */


/* here comes the "meat" : */
#include "init.c"
#include "control.c"
#include "execution.c"


void fc0_cycle() {
  /* read the doxxx to understand the order in which the
     functions are called (hint : counter-pipeline order
     that reduces the overhead caused by the duplication
     of the variables in the FF...) */

  /* control.c */
  fc0_cycle_writeback();
  fc0_cycle_Xbar_write();

  /* execution.c */
  fc0_cycle_ASU2();
  fc0_cycle_ROP2();
  fc0_cycle_ASU1();

  /* control.c */
  fc0_cycle_Xbar_read();
  fc0_cycle_decode();
  fc0_cycle_fetcher();

  /* others to come, stay tuned ! */

}


int main(int argc, char **argv) {

  if (argc <= 1)
    qdcpoc_error("need 1 arg : please give the input filename !", 5);

  init_fc0();
  elaborate_opcode_LUT();
  init_fetcher(argv[1]);

  do {
    fc0_cycle();
    get_next_instruction = 1; /* force the cycle so it does not loop endlessly */
  } while (1);

  return 0;
}
