/*

f-cpu/qdcpoc/execution.c
created Wed Jul 11 03:09:29 2001 by whygee@f-cpu.org

Beware ! don't do what is written here at home !
Don't let children look, or they'll be scared to death !

(C) YG all rights reserved. you're warned !!!

this file is included in f-cpu/qdcpoc/main.c

*/

void fc0_cycle_ASU1() {
}

void fc0_cycle_ASU2() {
}


void fc0_cycle_ROP2() {
  UMAX t5, tAND, tOR, tMUX;

  if (Xbar_EU_ROP2 !=0) {

/* stage 1.1 : */
    /* The ROP2 operation */
    t5 = (ROP2_function_bit0 & ~Xbar_read_port0 & ~Xbar_read_port1)
       | (ROP2_function_bit1 & ~Xbar_read_port0 &  Xbar_read_port1)
       | (ROP2_function_bit2 &  Xbar_read_port0 & ~Xbar_read_port1)
       | (ROP2_function_bit3 &  Xbar_read_port0 &  Xbar_read_port1);

/* stage 1.2 : */
    /* MUX opcode : */
    tMUX = (Xbar_read_port0 &  Xbar_read_port2)
         | (Xbar_read_port1 & ~Xbar_read_port2);

/* stage 2.1 : */
    /* a far better idea than a loop : */
    tAND = t5 & (t5 >> 1) & (t5 >> 2) & (t5 >> 4);
    tAND &= 0x0101010101010101LL;
    tAND |= (tAND << 1);
    tAND |= (tAND << 2);
    tAND |= (tAND << 4);

/* stage 2.2 : */
    tOR = t5 | (t5 >> 1) | (t5 >> 2) | (t5 >> 4);
    tOR &= 0x0101010101010101LL;
    tOR |= (tOR << 1);
    tOR |= (tOR << 2);
    tOR |= (tOR << 4);

/* stage 3 : */
    /* The final MUX : (this is not optimised for computing
        efficiency but shows how the VHDL looks like) */
    switch (Xbar_ROP2_mode) {
      case ROP2_DIRECT_MODE :  Xbar_ROP2_port = t5;    break; /* 0: normal */
      case ROP2_AND_MODE    :  Xbar_ROP2_port = tAND;  break; /* 1: AND */
      case ROP2_OR_MODE     :  Xbar_ROP2_port = tOR;   break; /* 2: OR */
      case ROP2_MUX_MODE    :  Xbar_ROP2_port = tMUX;  break; /* 3: MUX */
      default: fprintf(stderr,"Error in Case"); exit(13);
    }
  }
}

  /* others to come */
